API
Core Resources

Charge activitiesNew

A charge activity is a record of something that happened to a Charge, such as a payment attempt, a payment failure, a skip, a reschedule or a refund. Charge activities give a timeline of a Charge together with a description of each event and, for failures, a suggested solution. Only charge activities created in the last 90 days are available.

This resource is new in the V2 reference. It also works when you send X-Recharge-Version: 2021-11.

#The charge activity object

Attributes

  • idinteger
    The unique numeric identifier for the charge activity.
  • An object containing additional details about the event. Its contents depend on the activity_type and activity_sub_type.
    Show child attributesHide child attributes3
    • A human-readable description of the event.
    • A suggested way to resolve the issue, when the event is a failure. An empty string when there is no suggestion.
  • A more specific classification of the event within its activity_type, such as card_declined for a payment_failure. Can be an empty string.
  • The type of event that was recorded, such as payment_success, payment_failure, skipped, rescheduled or refund_success.
  • address_idinteger
    The ID of the Address of the Charge.
  • The amount of the Charge at the time of the event.
  • charge_idinteger
    The ID of the Charge the activity belongs to.
  • includeobject
    An object containing the related resources requested with the include query parameter.
    Only returned when the include query parameter is passed.
    Show child attributesHide child attributes2
    • An array of PaymentMethods associated with the Charge of the activity.
      Only returned when include contains payment_methods.
    • chargeobject
      The Charge the activity belongs to.
      Only returned when include contains charge.
  • updated_atdatetime
    The date and time when the charge activity was last updated.
  • created_atdatetime
    The date and time when the charge activity was created.
  • The ID of the Customer the Charge belongs to.
  • external_payment_method_idstring · nullable
    The ID of the payment method as it appears in the payment processor system.
  • order_idinteger · nullable
    The ID of the Order associated with the activity, if any.
  • payment_method_idinteger · nullable
    The ID of the PaymentMethod used for the activity, if any.
  • payment_methods_infoarray of objects
    An array describing the payment methods in use when the event was recorded.
    Show child attributesHide child attributes7
    • The ID of the PaymentMethod.
    • The type of the payment method, such as CREDIT_CARD or PAYPAL.
    • brandstring · nullable
      The brand of the card.
      Only returned for card-based payment types.
    • last4string · nullable
      The last four digits of the card or bank account.
      Only returned for card-based and SEPA debit payment types.
    • exp_monthinteger · nullable
      The expiration month of the card.
      Only returned for card-based payment types.
    • exp_yearinteger · nullable
      The expiration year of the card.
      Only returned for card-based payment types.
    • paypal_emailstring · nullable
      The email address of the PayPal account.
      Only returned for PayPal payment methods.
  • store_idinteger
    The ID of the store the charge activity belongs to.
The charge activity object
{
  "charge_activity": {
    "id": 987654321,
    "address_id": 21317826,
    "charge_id": 100714428,
    "customer_id": 12345,
    "order_id": null,
    "payment_method_id": 55501,
    "store_id": 1234,
    "activity_details": {
      "charge_attempts": 1,
      "description": "Charge was successfully paid.",
      "links": {},
      "payment_gateway": "stripe",
      "payment_transaction_id": "ch_XXXXXXXXXXXXXXX",
      "presentment_currency": "USD",
      "suggested_solution": ""
    },
    "activity_sub_type": "attempt_success",
    "activity_type": "payment_success",
    "charge_amount": 13.14,
    "created_at": "2026-11-10T09:45:44+00:00",
    "external_payment_method_id": "pm_XXXXXXXXXXXXXXX",
    "payment_methods_info": [
      {
        "payment_method_id": 55501,
        "payment_type": "CREDIT_CARD",
        "brand": "visa",
        "exp_month": 12,
        "exp_year": 2030,
        "last4": "4242"
      }
    ],
    "updated_at": "2026-11-10T09:45:44+00:00"
  }
}

#List charge activities

GET/charge_activities
Returns a list of charge activities created in the last 90 days. Either the read_orders or the read_payment_methods scope is sufficient.
Scopesread_ordersread_payment_methods

Query parameters

  • idsstring
    Filter charge activities by a comma-separated list of IDs.
  • charge_idinteger
    Filter charge activities by Charge.
  • address_idinteger
    Filter charge activities by Address.
  • Filter charge activities by PaymentMethod.
  • Filter charge activities by activity_type, such as payment_failure.
  • Filter charge activities by activity_sub_type, such as card_declined.
  • Show charge activities created after the given date. Must be within the last 90 days, which is also the default.
  • Show charge activities created before the given date. Must be within the last 90 days and cannot be in the future.
  • includestring
    A comma-separated list of related resources to return under the include attribute of each charge activity. payment_methods requires the read_payment_methods scope and charge requires the read_orders scope.
    Possible values
    payment_methodscharge
  • sort_bystring
    Sort listed charge activities in a specific order. Defaults to id-desc.
    Possible values
    id-ascid-desc
  • limitinteger
    The amount of results. The default is 50 and the maximum is 250.
  • pageinteger
    The page to show. Page-based pagination is deprecated; use cursor instead.
  • cursorstring
    The next_cursor or previous_cursor value returned by a previous call, used to retrieve the next or previous page of results. When passed, the only other parameter that can be passed is limit.
GET/charge_activities
curl 'https://api.rechargeapps.com/charge_activities' \
  -H 'X-Recharge-Version: v2' \
  -H 'X-Recharge-Access-Token: your_api_token'
Response
{
  "next_cursor": null,
  "previous_cursor": null,
  "charge_activities": [
    {
      "id": 987654321,
      "address_id": 21317826,
      "charge_id": 100714428,
      "customer_id": 12345,
      "order_id": null,
      "payment_method_id": 55501,
      "store_id": 1234,
      "activity_details": {
        "charge_attempts": 1,
        "description": "Charge was successfully paid.",
        "links": {},
        "payment_gateway": "stripe",
        "payment_transaction_id": "ch_XXXXXXXXXXXXXXX",
        "presentment_currency": "USD",
        "suggested_solution": ""
      },
      "activity_sub_type": "attempt_success",
      "activity_type": "payment_success",
      "charge_amount": 13.14,
      "created_at": "2026-11-10T09:45:44+00:00",
      "external_payment_method_id": "pm_XXXXXXXXXXXXXXX",
      "payment_methods_info": [
        {
          "payment_method_id": 55501,
          "payment_type": "CREDIT_CARD",
          "brand": "visa",
          "exp_month": 12,
          "exp_year": 2030,
          "last4": "4242"
        }
      ],
      "updated_at": "2026-11-10T09:45:44+00:00"
    }
  ]
}